TAIL(1)

NAME
tail - display the last part of a file

SYNOPSIS
tail -qv [ -f | -F | -r] [ -b number | -c number | -n number] [file ...]

DESCRIPTION
The tail utility displays the contents of file or, by default, its standard input, to the standard output.

The display begins at a byte, line or 512-byte block location in the input. Numbers having a leading plus (``+'') sign are relative to the beginning of the input, for example, “-c +2” starts the display at the second byte of the input. Numbers having a leading minus (``-'') sign or no explicit sign are relative to the end of the input, for example, “-n 2” displays the last two lines of the input. The default starting location is “-n 10”, or the last 10 lines of the input.

The options are as follows:

-b number
    The location is number 512-byte blocks.

-c number
    The location is number bytes.

-f  The -f option causes tail not to stop when end of file is reached, but rather to wait for additional data to be appended to the input. The -f option is ignored if there are no file arguments and the standard input is a pipe or a FIFO.

-F  The -F option is the same as the -f option, except that every five seconds tail will check to see if the file named on the command line has been shortened or moved (it is considered moved if the inode or device number changes) and, if so, it will close the current file, open the filename given, print out the entire contents, and continue to wait for more data to be appended. This option is used to follow log files though rotation by newsyslog(8) or similar programs.

-n number
    The location is number lines.

-q  Do not prepend a header for each file, even if multiple files are specified.

-r  The -r option causes the input to be displayed in reverse order, by line. Additionally, this option changes the meaning of the -b, -c and -n options. When the -r option is specified, these options specify the number of bytes, lines or 512-byte blocks to display, instead of the bytes, lines or blocks from the beginning or end of the input from which to begin the display. The default for the -r option is to display all of the input.

-v  Prepend each file with a header.

If more than a single file is specified, or the -v option is used, each file is preceded by a header consisting of the string “==> XXX <==” where “XXX” is the name of the file. The -q flag disables the printing of the header in all cases.

EXIT STATUS

SEE ALSO
cat(1), head(1), sed(1)

STANDARDS
The tail utility is expected to be a superset of the p1003.2-92 specification. In particular, the -b, -r and -F options are extensions to that standard.

The historic command line syntax of tail is supported by this implementation. The only difference between this implementation and historic versions of tail, once the command line syntax translation has been done, is that the -b, -c and -n options modify the -r option, i.e., ``-r -c 4'' displays the last 4 characters of the last line of the input, while the historic tail (using the historic syntax ``-4cr'') would ignore the -c option and display the last 4 lines of the input.

HISTORY
A tail command appeared in AT&T UNIX.

BUGS
When using the -F option, tail will not detect a file truncation if, between the truncation and the next check of the file size, data written to the file make it larger than the last known file size.